Index: trunk/NEMO/OPA_SRC/TRA/traadv_tvd.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 503)
@@ -4,4 +4,15 @@
    !! Ocean active tracers:  horizontal & vertical advective trend
    !!==============================================================================
+   !! History :       !  95-12  (L. Mortier)  Original code
+   !!                 !  00-01  (H. Loukos)  adapted to ORCA 
+   !!                 !  00-10  (MA Foujols E.Kestenare)  include file not routine
+   !!                 !  00-12  (E. Kestenare M. Levy)  fix bug in trtrd indexes
+   !!                 !  01-07  (E. Durand G. Madec)  adaptation to ORCA config
+   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!            9.0  !  04-01  (A. de Miranda, G. Madec, J.M. Molines ): advective bbl
+   !!            9.0  !  08-04  (S. Cravatte) add the i-, j- & k- trends computation
+   !!            " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!----------------------------------------------------------------------
+
 
    !!----------------------------------------------------------------------
@@ -11,5 +22,4 @@
    !!                  algorithm 
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
@@ -28,6 +38,5 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC tra_adv_tvd    ! routine called by step.F90
+   PUBLIC   tra_adv_tvd    ! routine called by step.F90
 
    !! * Substitutions
@@ -35,7 +44,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Header$
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -54,41 +63,26 @@
       !!
       !! ** Action : - update (ta,sa) with the now advective tracer trends
-      !!             - save the trends in (ttrdh,strdh) ('key_trdtra')
+      !!             - save the trends in (ztrdt,ztrds) ('key_trdtra')
+      !!----------------------------------------------------------------------
+      USE oce              , ztrdt => ua   ! use ua as workspace
+      USE oce              , ztrds => va   ! use va as workspace
       !!
-      !! History :
-      !!        !  95-12  (L. Mortier)  Original code
-      !!        !  00-01  (H. Loukos)  adapted to ORCA 
-      !!        !  00-10  (MA Foujols E.Kestenare)  include file not routine
-      !!        !  00-12  (E. Kestenare M. Levy)  fix bug in trtrd indexes
-      !!        !  01-07  (E. Durand G. Madec)  adaptation to ORCA config
-      !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-01  (A. de Miranda, G. Madec, J.M. Molines ): advective bbl
-      !!   9.0  !  08-04  (S. Cravatte) add the i-, j- & k- trends computation
-      !!    "   !  05-11  (V. Garnier) Surface pressure gradient organization
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      USE trdmod_oce         , ztay => tladj,  &  ! use tladj latter
-         &                     zsay => sladj,  &  ! use sladj latter
-         &                     ztaz => tladi,  &  ! use ua as workspace
-         &                     zsaz => sladi      ! use ua as workspace
-
-      !! * Arguments
-      INTEGER , INTENT( in ) ::   kt          ! ocean time-step index
-      REAL(wp), INTENT( in ), DIMENSION(jpi,jpj,jpk) ::   &
-         pun, pvn, pwn                        ! now ocean velocity fields
-
-      !! * Local declarations
+      INTEGER , INTENT(in)                         ::   kt    ! ocean time-step index
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pun   ! ocean velocity u-component
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pvn   ! ocean velocity v-component
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pwn   ! ocean velocity w-component
+      !!
       INTEGER  ::   ji, jj, jk              ! dummy loop indices
       REAL(wp) ::                        &  ! temporary scalar
          ztai, ztaj, ztak,               &  !    "         "   
-         zsai, zsaj, zsak                   !    "         "   
-      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   &
-         zti, ztu, ztv, ztw,             &  ! temporary workspace
-         zsi, zsu, zsv, zsw,             &  !    "           "
-         ztdta, ztdsa                       !    "           "
+         zsai, zsaj, zsak,               &  !    "         "   
+         z_hdivn_x, z_hdivn_y, z_hdivn
       REAL(wp) ::   &
-         z2dtt, zbtr, zeu, zev, zew, z2, &  ! temporary scalar
+         z2dtt, zbtr, zeu, zev,          &  ! temporary scalar
+         zew, z2, zbtr1,                 &  ! temporary scalar
          zfp_ui, zfp_vj, zfp_wk,         &  !    "         "
          zfm_ui, zfm_vj, zfm_wk             !    "         "
+      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zti, ztu, ztv, ztw   ! temporary workspace
+      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zsi, zsu, zsv, zsw   !    "           "
       !!----------------------------------------------------------------------
 
@@ -101,17 +95,7 @@
       ENDIF
 
-      IF( neuler == 0 .AND. kt == nit000 ) THEN
-         z2=1.
-      ELSE
-         z2=2.
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.
+      ELSE                                        ;    z2 = 2.
       ENDIF
-
-      ! Save ta and sa trends
-      IF( l_trdtra )   THEN
-         ztdta(:,:,:) = ta(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) 
-         l_adv = 'tvd'
-      ENDIF
-
 
       ! 1. Bottom value : flux set to zero
@@ -177,5 +161,4 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                zbtr = 1./ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-
                ! i- j- horizontal & k- vertical advective trends
                ztai = - ( ztu(ji,jj,jk) - ztu(ji-1,jj  ,jk  ) ) * zbtr
@@ -185,5 +168,4 @@
                zsaj = - ( zsv(ji,jj,jk) - zsv(ji  ,jj-1,jk  ) ) * zbtr
                zsak = - ( zsw(ji,jj,jk) - zsw(ji  ,jj  ,jk+1) ) * zbtr
-
                ! total intermediate advective trends
                zti(ji,jj,jk) = ztai + ztaj + ztak
@@ -193,17 +175,50 @@
       END DO
 
-     ! Save the intermediate vertical & j- horizontal advection trends
-     IF( l_trdtra )   THEN
+
+      ! Save the intermediate i / j / k advective trends for diagnostics
+      ! -------------------------------------------------------------------
+      ! Warning : We should use zun instead of un in the computations below, but we
+      ! also use hdivn which is computed with un, vn (check ???). So we use un, vn
+      ! for consistency. Results are therefore approximate with key_trabbl_adv.
+
+      IF( l_trdtra ) THEN
+         ztrdt(:,:,:) = 0.e0   ;   ztrds(:,:,:) = 0.e0
+         ! 
+         ! T/S ZONAL advection trends
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zbtr = 1./ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-                  ztay(ji,jj,jk) = - ( ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  ) ) * zbtr
-                  zsay(ji,jj,jk) = - ( zsv(ji,jj,jk) - zsv(ji  ,jj-1,jk  ) ) * zbtr
-                  ztaz(ji,jj,jk) = - ( ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1) ) * zbtr
-                  zsaz(ji,jj,jk) = - ( zsw(ji,jj,jk) - zsw(ji  ,jj  ,jk+1) ) * zbtr
+                  zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ztrdt(ji,jj,jk) = - ( ztu(ji,jj,jk) - ztu(ji-1,jj,jk) ) * zbtr
+                  ztrds(ji,jj,jk) = - ( zsu(ji,jj,jk) - zsu(ji-1,jj,jk) ) * zbtr
                END DO
             END DO
          END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_xad, 'TRA', kt)    ! save the trends
+         !
+         ! T/S MERIDIONAL advection trends
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zbtr      = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ztrdt(ji,jj,jk) = - ( ztv(ji,jj,jk) - ztv(ji,jj-1,jk) ) * zbtr
+                  ztrds(ji,jj,jk) = - ( zsv(ji,jj,jk) - zsv(ji,jj-1,jk) ) * zbtr
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_yad, 'TRA', kt)     ! save the trends
+         !
+         ! T/S VERTICAL advection trends
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.         
+                  zbtr      = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ztrdt(ji,jj,jk) = - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr
+                  ztrds(ji,jj,jk) = - ( zsw(ji,jj,jk) - zsw(ji,jj,jk+1) ) * zbtr
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_zad, 'TRA', kt)     ! save the trends
+         !
       ENDIF
 
@@ -244,6 +259,6 @@
       ! antidiffusive flux on k
       ! Surface value
-      ztw(:,:,1) = 0.
-      zsw(:,:,1) = 0.
+      ztw(:,:,1) = 0.e0
+      zsw(:,:,1) = 0.e0
 
       ! Interior value
@@ -290,50 +305,72 @@
       END DO
 
-      ! save the advective trends for diagnostic
-      ! tracers trends
-      IF( l_trdtra )   THEN
-         ! Compute the final vertical & j- horizontal advection trends
+
+      ! Save the advective trends for diagnostics
+      ! --------------------------------------------
+
+      IF( l_trdtra ) THEN
+         ztrdt(:,:,:) = 0.e0   ;   ztrds(:,:,:) = 0.e0
+         !
+         ! T/S ZONAL advection trends
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zbtr = 1./ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-                  ztay(ji,jj,jk) = - ( ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  ) ) * zbtr   &
-                     &             + ztay(ji,jj,jk) 
-                  zsay(ji,jj,jk) = - ( zsv(ji,jj,jk) - zsv(ji  ,jj-1,jk  ) ) * zbtr   &
-                     &             + zsay(ji,jj,jk) 
-                  ztaz(ji,jj,jk) = - ( ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1) ) * zbtr   &
-                     &             + ztaz(ji,jj,jk) 
-                  zsaz(ji,jj,jk) = - ( zsw(ji,jj,jk) - zsw(ji  ,jj  ,jk+1) ) * zbtr   &
-                     &             + zsaz(ji,jj,jk) 
+                  !-- Compute zonal divergence by splitting hdivn (see divcur.F90)
+                  !   N.B. This computation is not valid along OBCs (if any)
+                  zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  z_hdivn_x = (  e2u(ji  ,jj) * fse3u(ji  ,jj,jk) * pun(ji  ,jj,jk)          &
+                     &         - e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * pun(ji-1,jj,jk) ) * zbtr
+                  !-- Compute T/S zonal advection trends
+                  ztrdt(ji,jj,jk) = - ( ztu(ji,jj,jk) - ztu(ji-1,jj,jk) ) * zbtr + tn(ji,jj,jk) * z_hdivn_x
+                  ztrds(ji,jj,jk) = - ( zsu(ji,jj,jk) - zsu(ji-1,jj,jk) ) * zbtr + sn(ji,jj,jk) * z_hdivn_x
                END DO
             END DO
          END DO
-
-         ! horizontal advection: 
-         ! make the difference between the new trends ta()/sa() and the 
-         ! previous one ztdta()/ztdsa() to have the total advection trends 
-         ! to which we substract the vertical trends ztaz()/zsaz()
-         ztdta(:,:,:) = ta(:,:,:) - ztdta(:,:,:) - ztaz(:,:,:)
-         ztdsa(:,:,:) = sa(:,:,:) - ztdsa(:,:,:) - zsaz(:,:,:)
-
-         ! Add the term tn()/sn()*hdivn() to recover the Uh gradh(T/S) trends
-         ztdta(:,:,:) = ztdta(:,:,:) + tn(:,:,:) * hdivn(:,:,:)
-         ztdsa(:,:,:) = ztdsa(:,:,:) + sn(:,:,:) * hdivn(:,:,:)
-
-         CALL trd_mod(ztdta, ztdsa, jpttdlad, 'TRA', kt)
-
-         ! vertical advection: 
-         ! Substract the term tn()/sn()*hdivn() to recover the W gradz(T/S) trends
-         ztaz(:,:,:) = ztaz(:,:,:) - tn(:,:,:) * hdivn(:,:,:)
-         zsaz(:,:,:) = zsaz(:,:,:) - sn(:,:,:) * hdivn(:,:,:)
-
-         CALL trd_mod(ztaz, zsaz, jpttdzad, 'TRA', kt)
-
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_xad, 'TRA', kt, cnbpas='bis')   ! <<< ADD TO PREVIOUSLY COMPUTED
+         !
+         ! T/S MERIDIONAL advection trends
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  !-- Compute merid. divergence by splitting hdivn (see divcur.F90)
+                  !   N.B. This computation is not valid along OBCs (if any)
+                  zbtr      = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  z_hdivn_y = (  e1v(ji,  jj) * fse3v(ji,jj  ,jk) * pvn(ji,jj  ,jk)          &
+                     &         - e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * pvn(ji,jj-1,jk) ) * zbtr
+                  !-- Compute T/S meridional advection trends
+                  ztrdt(ji,jj,jk) = - ( ztv(ji,jj,jk) - ztv(ji,jj-1,jk) ) * zbtr + tn(ji,jj,jk) * z_hdivn_y          
+                  ztrds(ji,jj,jk) = - ( zsv(ji,jj,jk) - zsv(ji,jj-1,jk) ) * zbtr + sn(ji,jj,jk) * z_hdivn_y          
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_yad, 'TRA', kt, cnbpas='bis')   ! <<< ADD TO PREVIOUSLY COMPUTED
+         !
+         ! T/S VERTICAL advection trends
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zbtr1     = 1. / ( e1t(ji,jj) * e2t(ji,jj) )
+#if defined key_zco
+                  zbtr      = zbtr1
+                  z_hdivn_x = e2u(ji,jj)*pun(ji,jj,jk) - e2u(ji-1,jj)*pun(ji-1,jj,jk)
+                  z_hdivn_y = e1v(ji,jj)*pvn(ji,jj,jk) - e1v(ji,jj-1)*pvn(ji,jj-1,jk)
+#else
+                  zbtr      = zbtr1 / fse3t(ji,jj,jk)
+                  z_hdivn_x = e2u(ji,jj)*fse3u(ji,jj,jk)*pun(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk)*pun(ji-1,jj,jk)
+                  z_hdivn_y = e1v(ji,jj)*fse3v(ji,jj,jk)*pvn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk)*pvn(ji,jj-1,jk)
+#endif
+                  z_hdivn   = (z_hdivn_x + z_hdivn_y) * zbtr
+                  zbtr      = zbtr1 / fse3t(ji,jj,jk)
+                  ztrdt(ji,jj,jk) = - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr - tn(ji,jj,jk) * z_hdivn
+                  ztrds(ji,jj,jk) = - ( zsw(ji,jj,jk) - zsw(ji,jj,jk+1) ) * zbtr - sn(ji,jj,jk) * z_hdivn
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_zad, 'TRA', kt, cnbpas='bis')   ! <<< ADD TO PREVIOUSLY COMPUTED
+         !
       ENDIF
 
-      IF(ln_ctl) THEN
-         CALL prt_ctl(tab3d_1=ta, clinfo1=' tvd adv  - Ta: ', mask1=tmask, &
-            &         tab3d_2=sa, clinfo2=' Sa: ', mask2=tmask, clinfo3='tra')
-      ENDIF
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' tvd adv  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=sa, clinfo2=           ' Sa: ', mask2=tmask, clinfo3='tra' )
 
       ! "zonal" mean advective heat and salt transport
@@ -342,5 +379,5 @@
          pst_adv(:) = ptr_vj( zsv(:,:,:) )
       ENDIF
-
+      !
    END SUBROUTINE tra_adv_tvd
 
@@ -358,16 +395,6 @@
       !!       drange (1995) multi-dimensional forward-in-time and upstream-
       !!       in-space based differencing for fluid
-      !!
-      !! History :
-      !!        !  97-04  (L. Mortier) Original code
-      !!        !  00-02  (H. Loukos)  rewritting for opa8
-      !!        !  00-10  (M.A Foujols, E. Kestenare)  lateral b.c.
-      !!        !  01-03  (E. Kestenare)  add key_passivetrc
-      !!        !  01-07  (E. Durand G. Madec)  adapted for T & S
-      !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
       !!----------------------------------------------------------------------
-      !! * Arguments
-      REAL(wp), INTENT( in ) ::   &
-         prdt                               ! ???
+      REAL(wp), INTENT( in ) ::   prdt                               ! ???
       REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT( inout ) ::   &
          pbef,                            & ! before field
@@ -376,6 +403,5 @@
          pbb,                             & ! monotonic flux in the j direction
          pcc                                ! monotonic flux in the k direction
-
-      !! * Local declarations
+      !!
       INTEGER ::   ji, jj, jk               ! dummy loop indices
       INTEGER ::   ikm1
@@ -496,5 +522,5 @@
       CALL lbc_lnk( pbb, 'V', -1. )      ! changed sign
       CALL lbc_lnk( pcc, 'W',  1. )      ! NO changed sign
-
+      !
    END SUBROUTINE nonosc
 
